using System;
using System.IO.Ports;


namespace SerialTestCs
    {
    class main
        {
        static void Main(string[] args)
            {
            // Read command from console
            Console.Write("Command: ");
            string cmd = Console.ReadLine();

            SerialPort sp = new SerialPort();

            // COM port parameters
            sp.PortName = "COM5";
            sp.BaudRate = 115200;
            sp.DataBits = 8;
            sp.Parity = Parity.None;
            sp.StopBits = StopBits.One;
            
            // RTS/CTS handshaking
            sp.Handshake = Handshake.RequestToSend;
            sp.DtrEnable = true;

            // Error handling
            sp.DiscardNull = false;
            sp.ParityReplace = 0;

            try
                {
                sp.Open();

                // Append CR+LF to input and write to port
                sp.Write( cmd + "\r\n");

                DateTime lastRead = DateTime.Now;
                TimeSpan elapsedTime = new TimeSpan();
                
                // 2 second timespan
                TimeSpan TIMEOUT = new TimeSpan( 0, 0, 2 );

                // Read from port until TIMEOUT time has elapsed since
                // last successful read
                while (TIMEOUT.CompareTo(elapsedTime) > 0)
                    {
                    string buffer = sp.ReadExisting();

                    if( buffer.Length > 0 )
                        {
                        Console.Write(buffer);
                        lastRead = DateTime.Now;
                        }
                    elapsedTime = DateTime.Now - lastRead;
                    }

                sp.Close();
                }
            catch( Exception e )
                {
                System.Console.Write(e.Message);
                }
            }
        }
    }
